# $Id: sscr.y$
#
# Suser Simple Compiler by Ruby.

class Sscr

rule

program  : list_stmt 'EOF'

list_stmt: 
         | stmt list_stmt

stmt     : decl_int
         | stmt_if
         | stmt_while
         | stmt_print
         | stmt_input
         | stmt_return
         | block
         | expr ';'
         | ';'

decl_int   : 'INT' list_var ';'
           | 'INT' IDENT '(' list_var ')' '{' list_stmt '}' ';'
stmt_if    : 'IF' '(' expr ')' stmt
           | 'IF' '(' expr ')' stmt 'ELSE' stmt
stmt_while : 'WHILE' '(' expr ')' stmt
stmt_print : 'PRINT' list_exp ';'
stmt_input : 'INPUT' IDENT ';'
stmt_return: 'RETURN' ';'
           | 'RETURN' expr ';'

block    : '{' list_stmt '}'

list_var :
         | IDENT ',' list_var

list_exp :
         | expr ',' list_exp

expr     : exp_asn
         | exp_comp

exp_asn  : IDENT '=' expr

exp_comp : exp_add
         | exp_add '==' exp_add
         | exp_add '<=' exp_add
         | exp_add '>=' exp_add
         | exp_add '<'  exp_add
         | exp_add '>'  exp_add
         | exp_add '!=' exp_add

exp_add  : exp_mul
         | exp_mul  '+'  exp_add
         | exp_mul  '-'  exp_add

exp_mul  : primary
         | primary  '*'  exp_mul
         | primary  '/'  exp_mul

primary  : IDENT
         | '-' NUMBER
         | NUMBER
         | '(' expr ')'
         | IDENT '(' list_exp ')'


---- header
#

Node = Struct.new(:op, :left, :right)


---- inner
  
  def parse(str)
  end

  def next_token
  end

---- footer

parser = Calcp.new
